]> arthur.barton.de Git - ax-make.git/blobdiff - scripts/axify
axify: Fix quoting of output in Download() function
[ax-make.git] / scripts / axify
index b40d9182ea2ed02561613c4827e7451f84726715..160567d3915eb38ccfe99d660bf385251c526d9e 100755 (executable)
 
 NAME=`basename "$0"`
 
-[ -n "$1" ] && LIB_D="$1" || LIB_D="."
+Usage() {
+       echo "Usage: $NAME [-2|-3|-l <lic>] [<lib-dir>]"
+       echo
+       echo '  -2           Use the GNU GPLv2 for the COPYING file.'
+       echo '  -3           Use the GNU GPLv3 for the COPYING file.'
+       echo '  -l <lic>     Specify license to use for the COPYING file:'
+       echo '               <lic> can be "gpl2", "gpl3", "lgpl21", "lgpl3".'
+       echo '               By default an empty COPYING file is created.'
+       echo
+       echo "  <lib-dir>    Library directory. Default: current working directory."
+       echo
+       exit 2
+}
+
+Download() {
+       URL="$1"
+       FILE="$2"
+
+       echo "Downloading $URL to \"$FILE\" ..."
+
+       curl --version >/dev/null 2>&1
+       if [ $? -eq 0 ]; then
+               curl -#o "$FILE" "$URL" && return 0
+               echo "Failed to download $URL! [curl]"
+               return 1
+       fi
+
+       wget --version >/dev/null 2>&1
+       if [ $? -eq 0 ]; then
+               wget -qO "$FILE" --show-progress "$URL" && return 0
+               echo "Failed to download $URL! [wget]"
+               return 1
+       fi
+
+       echo "Can't download $URL, no download tool found!"
+       return 1
+}
+
+LIB_D="."
+LICENSE=""
+
+while true; do
+       case "$1" in
+               "-2")
+                       LICENSE="gpl2"
+                       ;;
+               "-3")
+                       LICENSE="gpl3"
+                       ;;
+               "-l")
+                       LICENSE="$2"
+                       shift
+                       ;;
+               "-"*)
+                       Usage
+                       ;;
+               *)
+                       break
+                       ;;
+       esac
+       shift
+done
+
+[ $# -gt 1 ] && Usage
+
+[ -n "$1" ] && LIB_D="$1"
 
 if [ -r "/usr/local/share/ax-make/Makefile.ax" ]; then
        MAKEFILE_AX="/usr/local/share/ax-make/Makefile.ax"
@@ -25,12 +90,16 @@ fi
 
 # -- Makefile.ax --
 
-[ ! -d "$LIB_D" ] && mkdir -pv "$LIB_D"
-if [ "$MAKEFILE_AX" -nt "$LIB_D/`basename "$MAKEFILE_AX"`" ]; then
-       echo "Updating \"$LIB_D/`basename "$MAKEFILE_AX"`\" ..."
-       cp -v "$MAKEFILE_AX" "$LIB_D/`basename "$MAKEFILE_AX"`" || exit 1
+if [ ! -d "$LIB_D" ]; then
+       mkdir -pv "$LIB_D" || exit 1
+fi
+
+target="$LIB_D/`basename "$MAKEFILE_AX"`"
+if [ ! -e "$target" -o "$MAKEFILE_AX" -nt "$target" ]; then
+       echo "Updating \"$target\" ..."
+       cp -v "$MAKEFILE_AX" "$target" || exit 1
 else
-       echo "Makefile \"$LIB_D/`basename "$MAKEFILE_AX"`\" is up to date."
+       echo "Makefile \"$target\" is up to date."
 fi
 
 # -- Project Makefile's ---
@@ -62,9 +131,42 @@ fi
 
 # --- Standard project files ---
 
+if [ ! -e AUTHORS ]; then
+       if git --version >/dev/null 2>&1; then
+               echo "Creating \"AUTHORS\" file ..."
+               echo "`git config user.name` <`git config user.email`>" >>AUTHORS
+       fi
+fi
+
+if [ ! -e COPYING ]; then
+       LICENSE_URL=""
+       case "$LICENSE" in
+               "")
+                       ;;
+               "gpl2")
+                       LICENSE_URL="http://www.gnu.org/licenses/gpl-2.0.txt"
+                       ;;
+               "gpl3")
+                       LICENSE_URL="http://www.gnu.org/licenses/gpl-3.0.txt"
+                       ;;
+               "lgpl21")
+                       LICENSE_URL="https://www.gnu.org/licenses/lgpl-2.1.txt"
+                       ;;
+               "lgpl3")
+                       LICENSE_URL="https://www.gnu.org/licenses/lgpl-3.0.txt"
+                       ;;
+               *)
+                       echo "Can't setup unknown \"$LICENSE\" license!"
+                       ;;
+       esac
+       [ -n "$LICENSE_URL" ] && Download "$LICENSE_URL" COPYING
+else
+       [ -n "$LICENSE" ] && echo "COPYING file already exists, skipping."
+fi
+
 for f in AUTHORS COPYING README; do
        if [ ! -e "$f" ]; then
-               echo "Creating empty \"$f\" ..."
+               echo "Creating empty \"$f\" file ..."
                touch "$f"
        fi
 done